<script lang="ts">
import Vue from 'vue';
import { init, refresh } from 'aos';
import { getPageMetadata } from '../common/meta';
import { NextStep } from '@/components/common/index.vue';
import { filterFeaturesHelper } from '~/lib/processFeaturesHelper';

import {
  FeaturesLandingHero,
  FeaturesMenu,
  FeaturesCopyMedia,
} from '@/components/features/index';

import SdlcFeaturesTable from '@/components/platform/sdlc-features-table.vue';

export default Vue.extend({
  components: {
    NextStep,
    FeaturesLandingHero,
    FeaturesMenu,
    FeaturesCopyMedia,
    SdlcFeaturesTable,
  },
  async asyncData({ $content, error }: any) {
    const categoriesObject = await $content('synced/categories').fetch();
    const featuresFetch = await $content('synced/features').fetch();

    try {
      const data = await $content(`platform`).fetch();
      const doc = await $content(`features`)
        .where({ slug: { $contains: ['features-partial'] } })
        .sortBy('slug', 'asc')
        .fetch();

      // START FEATURES TABLE CODE
      const table = {
        plan: [],
        create: [],
        verify: [],
        secure: [],
        package: [],
        release: [],
        configure: [],
        monitor: [],
        govern: [],
        manage: [],
      };

      // populate table arrays with category content by stage value
      Object.entries(categoriesObject).forEach(([_, value]) => {
        if (table[value.stage] && value.maturity && value.marketing !== false) {
          table[value.stage].push({
            name: value.name,
            stage: value.stage,
            documentation: value.documentation || null,
            direction: value.direction || null,
            marketing_page: value.marketing_page || null,
            maturity: value.maturity,
          });
        }
      });

      // START FEATURES TAB CODE
      const features = doc.reduce((previous: any, current: any) => {
        const mergedFeature = {
          ...previous,
          ...current,
        };

        return mergedFeature;
      });

      features.tabs.forEach((tab: any) => {
        const stageFormatted = tab.text.toLowerCase();
        const categoryList: any = [];
        Object.entries(categoriesObject).forEach(([key, value]) => {
          const itemValue = value as any;
          if (itemValue?.stage?.includes(stageFormatted)) {
            categoryList.push({ slug: key, name: itemValue?.name });
          }
        });

        const featuresArray = categoryList.map((category: any) => {
          return {
            ...category,
            features: filterFeaturesHelper(
              featuresFetch.features,
              features.content_config.filter_features_by,
              category.slug,
            ),
          };
        });
        features[stageFormatted].features = featuresArray;
      });

      return { data, features, table };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },

  data() {
    return {
      selectedTab: '',
      contentFilter: {
        plan: '',
      },
    };
  },
  head() {
    return getPageMetadata((this as any).data, this.$route.path);
  },
  beforeMount() {
    init({
      once: true,
    });
  },
  mounted() {
    refresh();
    this.selectedTab = this.$route.query.stage
      ? this.$route.query.stage
      : (this as any).features.tabs[0].text.toLowerCase();

    if (!this.$route.query.stage) {
      this.$router.replace({
        path: '',
        query: { stage: this.selectedTab },
        replace: true,
      });
    }
  },
  methods: {
    onTabChange(tab: string) {
      this.selectedTab = tab;
      this.contentFilter = {
        plan: '',
      };
    },
  },
});
</script>

<template>
  <div class="platform-page">
    <section class="hero">
      <SlpContainer>
        <div class="flex">
          <div data-aos="fade-up" data-aos-duration="800">
            <SlpTypography tag="h1" variant="heading2-bold">{{
              data.header
            }}</SlpTypography>
            <div class="buttons">
              <SlpButton
                variant="primary"
                :href="data.cta_primary.href"
                :data-ga-name="data.cta_primary.data_ga_name"
                :data-ga-location="data.cta_primary.data_ga_location"
                >{{ data.cta_primary.text }}
              </SlpButton>
              <SlpButton
                variant="tertiary"
                :href="data.cta_secondary.href"
                :data-ga-name="data.cta_secondary.data_ga_name"
                :data-ga-location="data.cta_secondary.data_ga_location"
                >{{ data.cta_secondary.text }}
                <SlpIcon
                  class="slp-ml-8"
                  name="chevron-lg-right"
                  variant="product"
                  slp-color="primary-50"
                  alt="Chevron Right Icon"
              /></SlpButton>
            </div>
          </div>

          <nuxt-img
            :src="data.img.url"
            :alt="data.img.alt"
            data-aos="fade-up"
            data-aos-duration="1000"
          />
        </div>
      </SlpContainer>
    </section>
    <SdlcFeaturesTable :content="data.platform_features" :table="table" />
    <SlpContainer>
      <FeaturesLandingHero :data="features.call_to_action" :is-hero="false" />
      <FeaturesMenu
        v-if="selectedTab"
        :tabs="features.tabs"
        :default-tab="selectedTab"
        :dropdown-label="features.dropdown_label"
        @tabChange="onTabChange"
      />
      <template v-if="features[selectedTab]">
        <FeaturesCopyMedia
          :data="features[selectedTab]['copy_media']"
          :features="features[selectedTab].features"
          :external="true"
        />
      </template>
    </SlpContainer>
    <section class="cards">
      <SlpContainer>
        <div class="card-grid">
          <a
            v-for="card in data.cards"
            :key="card.text"
            class="minimal-card"
            :href="card.link.href"
            :data-ga-name="card.link.data_ga_name"
            :data-ga-location="card.link.data_ga_location"
          >
            <div>
              <SlpIcon
                variant="marketing"
                :name="card.icon"
                hex-color="171321"
              /><SlpTypography variant="all-caps" tag="p">{{
                card.type
              }}</SlpTypography>
            </div>
            <SlpTypography class="card-text" variant="body1" tag="p">{{
              card.text
            }}</SlpTypography>
            <SlpButton variant="ghost"
              >Learn more <SlpIcon variant="product" name="chevron-lg-right"
            /></SlpButton>
          </a>
        </div>
      </SlpContainer>
    </section>
    <SlpContainer variant="gradient">
      <NextStep />
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.platform-page {
  overflow-x: hidden;
}
.hero {
  padding: $spacing-64 0;
  background: $color-surface-700;
  color: $color-text-50;

  @media (max-width: $breakpoint-md) {
    padding: $spacing-32 0;
  }

  .flex {
    display: flex;
    align-items: center;
    position: relative;

    @media (max-width: $breakpoint-md) {
      flex-direction: column;
    }

    h1 {
      flex: 1 0 50%;

      @media (max-width: $breakpoint-md) {
        margin-bottom: $spacing-16;
      }
    }

    img {
      display: block;
      width: 100%;
      max-width: 550px;
    }
  }

  .buttons {
    margin-top: $spacing-16;
    display: flex;

    @media (max-width: $breakpoint-md) {
      flex-direction: column;
    }

    .slp-btn-primary {
      background: $color-surface-50;
      color: $color-text-300;
      margin-right: $spacing-8;

      &:hover {
        background: $color-surface-200;
      }
    }

    .slp-btn-tertiary {
      color: $color-text-50;

      .slp-icon {
        margin-left: $spacing-8;
      }

      @media (max-width: $breakpoint-md) {
        margin-bottom: $spacing-48;
      }
    }

    .slp-btn-primary,
    .slp-btn-tertiary {
      @media (max-width: $breakpoint-md) {
        justify-content: center;
      }
    }
  }
}

.cards {
  background: $color-surface-800;

  .card-grid {
    display: flex;
    justify-content: space-between;
    align-items: flex-start;
    padding: $spacing-96 0;

    @media (max-width: $breakpoint-md) {
      flex-direction: column;
      padding: $spacing-64 0;
    }
  }

  .minimal-card {
    max-width: 350px;
    min-height: 272px;
    width: 100%;
    background: $color-surface-50;
    padding: $spacing-32 $spacing-16;
    transition: border-radius 0.3s ease-in;

    &:hover {
      border-radius: 0px 0px 90px 0px;
    }

    @media (max-width: $breakpoint-md) {
      margin-bottom: $spacing-24;
    }

    div {
      display: flex;

      p {
        margin-left: $spacing-8;
        color: $color-text-300;
      }
    }

    .card-text {
      color: $color-text-300;
      margin-top: $spacing-24;
      margin-bottom: $spacing-64;
    }

    .slp-btn-ghost {
      color: inherit;
      font-weight: $font-weight-bold;

      .slp-icon {
        margin-left: $spacing-8;
      }
    }
  }
}
</style>
